NestingKind (Java Platform SE 8 )
Keywords: javax.lang.model.element.NestingKind class
Date: 2020-03-26

compact3
javax.lang.model.element

## Enum NestingKind

- java.lang.Object
- - java.lang.Enum<NestingKind>
  - - javax.lang.model.element.NestingKind

- All Implemented Interfaces:
    Serializable, Comparable<NestingKind>

      public enum NestingKind
      extends Enum<NestingKind>

  The nesting kind of a type element. Type elements come in four varieties: top-level, member, local, and anonymous. Nesting kind is a non-standard term used here to denote this classification.

  Note that it is possible additional nesting kinds will be added in future versions of the platform.

  Example: The classes below are annotated with their nesting kind.

  >      import java.lang.annotation.*;
  >      import static java.lang.annotation.RetentionPolicy.*;
  >      import javax.lang.model.element.*;
  >      import static javax.lang.model.element.NestingKind.*;

  >      @Nesting(TOP_LEVEL)
  >      public class NestingExamples {
  >          @Nesting(MEMBER)
  >          static class MemberClass1{}

  >          @Nesting(MEMBER)
  >          class MemberClass2{}

  >          public static void main(String... argv) {
  >              @Nesting(LOCAL)
  >              class LocalClass{};

  >              Class<?>[] classes = {
  >                  NestingExamples.class,
  >                  MemberClass1.class,
  >                  MemberClass2.class,
  >                  LocalClass.class
  >              };

  >              for(Class<?> clazz : classes) {
  >                  System.out.format("%s is %s%n",
  >                                    clazz.getName(),
  >                                    clazz.getAnnotation(Nesting.class).value());
  >              }
  >          }
  >      }

  >      @Retention(RUNTIME)
  >      @interface Nesting {
  >          NestingKind value();
  >      }

  Since:
    1.6

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `ANONYMOUS` A type without a name.
    `LOCAL` A named type declared within a construct other than a type.
    `MEMBER` A type that is a named member of another type.
    `TOP_LEVEL` A top-level type, not contained within another type.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `isNested()` Does this constant correspond to a nested type element? A nested type element is any that is not top-level.
    `static NestingKind` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static NestingKind[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### TOP_LEVEL

          public static final NestingKind TOP_LEVEL

      A top-level type, not contained within another type.

    - #### MEMBER

          public static final NestingKind MEMBER

      A type that is a named member of another type.

    - #### LOCAL

          public static final NestingKind LOCAL

      A named type declared within a construct other than a type.

    - #### ANONYMOUS

          public static final NestingKind ANONYMOUS

      A type without a name.

  - ### Method Detail

    - #### values

          public static NestingKind[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (NestingKind c : NestingKind.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static NestingKind valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### isNested

          public boolean isNested()

      Does this constant correspond to a nested type element? A nested type element is any that is not top-level. An inner type element is any nested type element that is not static.
      Returns:
        whether or not the constant is nested

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2020, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.